import java.io.*;
import java.util.*;

import dinamiche.*;

public class LeggiStudenti
{
	public static void main(String[] argv)
	{
		File f = new File(argv[0]);
		FileReader fr = null;
		try
		{
			fr = new FileReader(f);
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			System.exit(1);
		}
		BufferedReader br = new BufferedReader(fr);

		boolean continua = true;
		OrderedList l = new OrderedList();
		do
		{
			Studente s = null;
			String tipoStud = br.readLine();
			if(tipoStud.equals("STATISTICA"))
			{
				s = new StudenteStatistica();
			}
			else if(tipoStud.equals("ASTRONOMIA"))
			{
				s = new StudenteAstronomia();
			}
			else if(tipoStud.equals("LEGGE"))
			{
				s = new StudenteLegge();
			}
			else
			{
				System.err.println("Studente tipo <" + tipoStud + "> non gestibile");
				break;
			}
			continua = s.populate(br);
			if(continua)
			{
				l.addInOrder(s);
			}
		}
		while(continua);

		try
		{
			br.close();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}

		System.out.println(l);

		FileWriter fw = null;
		try
		{
			fw = new FileWriter(f);
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			System.exit(1);
		}
		PrintWriter pw = new PrintWriter(fw);
		ListIterator iter = l.listIterator();
		while(iter.hasNext())
		{
			Studente s = (Studente)iter.next();
			pw.print(s);
		}
		pw.close();

	}
}
