package dinamiche;

public class Nodo<E>
{
	protected E dato;
	protected Nodo<E> next;

	public Nodo(E ilDato, Nodo<E> ilProssimo)
	{
		dato = ilDato;
		next = ilProssimo;
	}

	public Nodo(E ilDato)
	{
		this(ilDato, null);
	}

	Nodo(Nodo<E> ilProssimo)
	{
		this(null, ilProssimo);
	}

	Nodo()
	{
		this(null, null);
	}

	public Nodo<E> getNext()
	{
		return next;
	}

	public void setNext(Nodo<E> nuovoProssimo)
	{
		next = nuovoProssimo;
	}

	public E getDato()
	{
		return dato;
	}

	public boolean equals(Object o)
	{
		return dato.equals( ((Nodo)o).dato);
	}

	public String toString()
	{
		if(dato == null)
		{
			return "Il nodo contiene <null>";
		}
		return "Il nodo contiene <" + dato.toString()+ ">";
	}
}
