package eventi;

import java.util.*;
import java.io.*;

public class Schedulatore
{
	List<Evento> passato, futuro;
	Map<String, Evento> tutti;

	BufferedReader stdin;

	public Schedulatore()
	{
		stdin = new BufferedReader(new InputStreamReader(System.in));
		passato = new LinkedList<Evento>();
		futuro = new LinkedList<Evento>();
		tutti = new HashMap<String, Evento>();
	}

	void evento()
	{
		long scad = -1;
		String id = null;
		try
		{
			System.out.print("ID ? >");
			id = stdin.readLine();
			System.out.print("Scadenza ? > ");
			scad = Long.parseLong(stdin.readLine());
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return;
		}
		catch(NumberFormatException nfe)
		{
			nfe.printStackTrace();
			return;
		}

		Evento e = new Evento(id, scad);
		futuro.add(e);
		tutti.put(id, e);
		Collections.sort(futuro);
	}

	void scaduti()
	{
		long now = -1;
		try
		{
			System.out.print("Istante corrente ? > ");
			now = Long.parseLong(stdin.readLine());
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return;
		}
		catch(NumberFormatException nfe)
		{
			nfe.printStackTrace();
			return;
		}

		boolean ordina = false;
		ListIterator<Evento> iter = futuro.listIterator();
		while(iter.hasNext())
		{
			Evento e = iter.next();
			if(e.scadenza > now)
			{
				break;
			}
			iter.remove();
			System.out.println(e);
			e.scaduto = true;
			passato.add(e);
			ordina = true;
		}
		if(ordina)
		{
			Collections.sort(passato);
		}
	}

	void storico()
	{
		System.out.println("Eventi scaduti: " + passato);
	}

	void elenco()
	{
		System.out.println("Eventi futuribili: " + futuro);
	}

	void rischedula()
	{
		String id = null;
		long newScad = -1;
		try
		{
			System.out.print("ID evento da rischedulare ? > ");
			id = stdin.readLine();
			System.out.print("Nuova scadeza ? > ");
			newScad = Long.parseLong(stdin.readLine());
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return;
		}
		catch(NumberFormatException nfe)
		{
			nfe.printStackTrace();
			return;
		}

		Evento e = tutti.get(id);
		if(e == null)
		{
			System.err.println("Evento di id <" + id + "> non presente");
			return;
		}

		e.scadenza = newScad;
		if(e.scaduto)
		{
			e.scaduto = false;
			// visto che cerco una specifica istanza la semantica di equals
			// della classe Object e' adeguata.
			passato.remove(e);
			futuro.add(e);
		}
		Collections.sort(futuro);
	}

	void rimuovi()
	{
		String id = null;
		try
		{
			System.out.print("ID evento da rimuovere ? > ");
			id = stdin.readLine();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return;
		}

		Evento e = tutti.remove(id);
		if(e == null)
		{
			System.err.println("Evento di id <" + id + "> non presente");
			return;
		}

		if(e.scaduto)
		{
			// visto che cerco una specifica istanza la semantica di equals
			// della classe Object e' adeguata.
			passato.remove(e);
		}
		else
		{
			// visto che cerco una specifica istanza la semantica di equals
			// della classe Object e' adeguata.
			futuro.remove(e);
		}
	}
}
