package mediateca;

import java.io.*;

public class Dvd extends Media
{
	String regista;
	int annoUscita;
	String cast;

	public String toString()
	{
		return "Dvd\n" + super.toString() + regista + "\n" + annoUscita + "\n" + cast + "\n";
	}

	public boolean equals(Object o)
	{
		Dvd d = (Dvd)o;
		return (super.equals(d) && regista.equals(d.regista));
	}

	public boolean populate(BufferedReader br)
	{
		if(!super.populate(br))
		{
			return false;
		}
		try
		{
			regista = br.readLine();
			if(regista == null)
			{
				return false;
			}

			try
			{
				annoUscita = Integer.parseInt(br.readLine());
			}
			catch(NumberFormatException nfe)
			{
				nfe.printStackTrace();
				return false;
			}

			cast = br.readLine();
			if(cast == null)
			{
				return false;
			}
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return false;
		}
		return true;
	}
}
