package terminal;

import java.io.*;

public class Transito
{
	int data; // da 1 a 31
	String tipo;
	String ditta;
	String dest;

	public Transito()
	{
		data = -1;
		tipo = ditta = dest = null;
	}

	public boolean equals(Object o)
	{
		Transito t = (Transito)o;
		return ( (data == t.data) && (tipo.equals(t.tipo)) &&
		(ditta.equals(t.ditta)) && (dest.equals(t.dest)) );
	}

	public String toString()
	{
		return "Merce transitata il giorno " + data + "; merce di tipo " + tipo + "; trasportata dalla ditta " + ditta + "; diretta a " + dest + ". ";
	}

	public String serializza()
	{
		return data + "\n" + tipo + "\n" + dest + "\n" + ditta + "\n";
	}

	public boolean popola(BufferedReader br)
	{
		try
		{
			String line = br.readLine();
			if(line == null)
			{
				return false;
			}
			data = Integer.parseInt(line);
			if(data < 1 || data > 31)
			{
				//return false;
				throw new IllegalArgumentException(String.valueOf(data) + " out of range");
			}
		}
		catch(NumberFormatException nfe)
		{
			nfe.printStackTrace();
			return false;
		}
		catch(IllegalArgumentException iae)
		{
			iae.printStackTrace();
			return false;
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return false;
		}

		try
		{
			tipo = br.readLine();
			if(tipo == null)
			{
				return false;
			}
	
			dest = br.readLine();
			if(dest == null)
			{
				return false;
			}

			ditta = br.readLine();
			if(ditta == null)
			{
				return false;
			}
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return false;
		}
		return true;
	}
}
